package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;

public class PosicaoDeEstoquePage extends PageBase  {

    //Evento de loading da pagina:
        By loadingWait = By.xpath("//*[@class='zh-loading-desc ng-binding']");


    //BUSCA DO PRODUTO ATRAVES DO FLOAT-CONTROL:

        By campoProcurarFloatControl = By.xpath("//*[@id='popup']//*[@placeholder='Procurar']");
        By IconSearch = By.xpath("//*[@data-zh-id='filter-floating-card']//*[@zh-icon='search no-border icon-white']");


    //RELATORIO:
        By tabIndexRelatorio = By.xpath("//*[@data-zh-id='66119073736804857762862']//*[@tabindex = '0']");
        By PosicaoDeEstoque = By.id("ijk");



        By modeloRelatorio = By.xpath("//*[@data-zh-id='66119073736804857762862']//*[@tabindex = '0']");
       By cabecalho = By.xpath("//*[@data-zh-id='6611907371524742479136']//*[@tabindex = '0']");


    //REPETE_CABEÇALHO:
        By tabRepeteCabecalho = By.xpath("//*[@data-zh-id='6611907371524742479136']//*[@tabindex = '0']");
        By OpcaoSim = By.xpath("//*[@data-zh-id='6611907371524742479136']//*[@tabindex = '0']//*[@data-value= '0']");


    //UNIDADE:
        By btnXlimpar = By.xpath("//*[@data-zh-id='6611907373137353202863']//*[@zh-icon='no-border close-x']");
        By IconeUnidade = By.xpath("//*[@data-zh-id='6611907373137353202863']//*[@id='NMFILIAL']/span[1]");
        By SelecioanarUnidadeAjusteIventario = By.xpath("//*[@data-zh-field-name='NMFILIAL']//*[.='HELA INGREDIENTES BRASIL']");


    //DATA_POSIÇÃO:
        By btnXlimparDataPosicao = By.xpath("//*[@data-zh-id='66119073741875895512867']//*[@zh-icon='no-border close-x']");
        By IconCalendario = By.xpath("//*[@data-zh-id='66119073741875895512867']//*[@class='zh-icon zh-icon-calendar zh-icon-no-border']");
        By DataEscolhida = By.xpath("//div[@class='day today']");//Nao precisa de data-zh-id


    //ALMOXARIFADO:
        By IconSearchAlmoxarife = By.xpath("//*[@data-zh-id='6611907378607519402868']//*[@id='DSALMOXARIFE']/span[1]");
        By almoxarifado = By.xpath("//*[@id='grid-9000']//*[.='HELA MATRIZ']");//Nao precisa de data-zh-id


    //TIPO_DE_CUSTO:
        By btnXlimparTipoDeCusto = By.xpath("//*[@data-zh-id='66119073733422378462875']//*[@zh-icon='no-border close-x']");
        By IconSearchTipoDeCusto = By.xpath("//*[@data-zh-id='66119073733422378462875']//*[@id='NMTIPOCUSTO']/span[1]");
        By TipoDeCusto = By.xpath("//*[@id='grid-9000']//*[.='Custo Médio Líquido Atual']");//Nao precisa de data-zh-id


    //NIVEL P/TOTALIZAÇÃO:
        By tabIndexNivelTotalizacao = By.xpath("//*[@data-zh-id='66119073723130806132878']//*[@tabindex = '0']");
        By NivelTotalizacao = By.xpath("//*[@data-zh-id='66119073723130806132878']//*[@data-value= '0']");


    //ORDERNAR POR NOME:
        By tabIndexOrdernarPorNome = By.xpath("//*[@data-zh-id='66119073720788263272879']//*[@tabindex = '0']");
        By OrdernarPorNome = By.xpath("//*[@data-zh-id='66119073720788263272879']//*[@data-value= '0']");


    //PRODUTO INICIAL:
        By IconSearchProdutoInicial = By.xpath("//*[@data-zh-id='66119073733548131952880']//*[@id='NMPRODUTOINI']/span[1]");
        By produto = By.xpath("//*[@id='grid-9000']//*[.='Hela Poultry Broth Paste Clear KG']");//Nao precisa de data-zh-id


    //PRODUTO FINAL:
        By IconSearchProdutoFinal = By.xpath("//*[@data-zh-id='66119073720257794042884']//*[@id='NMPRODUTOFIN']/span[1]");
        By produtoFinal = By.xpath("//*[@id='grid-9000']//*[.='Hela Poultry Broth Paste Clear KG']");//Nao precisa de data-zh-id


    //EM GRID:
        By btnEmGrid = By.xpath("//*[@data-zh-id='6611907374266333116827']");
        By gridRelatorioPosicao = By.xpath("//span[text()='Custo Médio Líquido Atual']");
       By validarGrid = By.xpath("//span[text()='Custo Médio Líquido Atual']");

    //PDF
    By gerarPDF = By.xpath("//*[@data-zh-id='6611907373562330536137']");



    // XLSX
    By gerarXLSX = By.xpath("//*[@data-zh-id='661190737176416544139']");
    public void indexRelatorio(){
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(tabIndexRelatorio);
        click(tabIndexRelatorio);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
   public void posicaoDeEstoque(){
        waitForVisibilityOfElementLocated(PosicaoDeEstoque);
        click(PosicaoDeEstoque);
        waitForInvisibilityOfElementLocated(loadingWait);
    }

   public void selecionarRelatorio(){
        waitForVisibilityOfElementLocated(modeloRelatorio);
        click(modeloRelatorio);
        waitForInvisibilityOfElementLocated(loadingWait);
   }
   public void selecionarRepeteCabecalho(){
        waitForVisibilityOfElementLocated(cabecalho);
        click(cabecalho);
        waitForInvisibilityOfElementLocated(loadingWait);
   }
    public void repeteCabecalho(){
        waitForVisibilityOfElementLocated(tabRepeteCabecalho);
        click(tabRepeteCabecalho);
    }
    public void selecionarOpcao(){
        waitForVisibilityOfElementLocated(OpcaoSim);
        click(OpcaoSim);
    };
    public void limparUnidade(){
        waitForVisibilityOfElementLocated(btnXlimpar);
        click(btnXlimpar);
    };
    public void campoUnidade(){
        waitForVisibilityOfElementLocated(IconeUnidade);
        click(IconeUnidade);
    }
    public void buttonbusca(){
        waitForVisibilityOfElementLocated(IconSearch);
        click(IconSearch);
        waitForInvisibilityOfElementLocated(loadingWait);
    };
    public void buscarUnidade(String descUnidade){
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl,descUnidade);
        waitForInvisibilityOfElementLocated(loadingWait);
    };
    public void selecionarUnidade(){
        waitForVisibilityOfElementLocated(SelecioanarUnidadeAjusteIventario);
        click(SelecioanarUnidadeAjusteIventario);
    };
    public void limparPosicao(){
        waitForVisibilityOfElementLocated(btnXlimparDataPosicao);
        click(btnXlimparDataPosicao);
    };
    public void campoCalendario(){
        waitForVisibilityOfElementLocated(IconCalendario);
        click(IconCalendario);
        waitForInvisibilityOfElementLocated(loadingWait);
    };
    public void selecionarData(){
        waitForVisibilityOfElementLocated(DataEscolhida);
        click(DataEscolhida);
        waitForInvisibilityOfElementLocated(loadingWait);
    };
    public void campoAlmoxarifado(){
        waitForVisibilityOfElementLocated(IconSearchAlmoxarife);
        click(IconSearchAlmoxarife);
        waitForInvisibilityOfElementLocated(loadingWait);
    };
    public void buscarAlmoxarifado(String descAlmoxarifado){
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl,descAlmoxarifado);
        waitForInvisibilityOfElementLocated(loadingWait);
    };
    public void selecionarAlmoxarifado(){
        waitForVisibilityOfElementLocated(almoxarifado);
        click(almoxarifado);
    }
    public void limparTipoDeCusto(){
        waitForVisibilityOfElementLocated(btnXlimparTipoDeCusto);
        click(btnXlimparTipoDeCusto);
        waitForInvisibilityOfElementLocated(loadingWait);
    };
    public void buttonTipoDeCusto(){
        waitForVisibilityOfElementLocated(IconSearchTipoDeCusto);
        click(IconSearchTipoDeCusto);
        waitForInvisibilityOfElementLocated(loadingWait);
    };
    public void buscarTipoDeCusto(String descTipoDeCusto){
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl,descTipoDeCusto);
        waitForInvisibilityOfElementLocated(loadingWait);
    };
    public void selecionarTipoDeCusto(){
        waitForVisibilityOfElementLocated(TipoDeCusto);
        click(TipoDeCusto);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void nivelDeTotalizacao(){
        waitForVisibilityOfElementLocated(tabIndexNivelTotalizacao);
        click(tabIndexNivelTotalizacao);
        waitForInvisibilityOfElementLocated(loadingWait);
    };
    public void selecionarNivelDeTotalizacao(){
        waitForVisibilityOfElementLocated(NivelTotalizacao);
        click(NivelTotalizacao);
        waitForInvisibilityOfElementLocated(loadingWait);
    };
    public void ordenarPorNome(){
        waitForVisibilityOfElementLocated(tabIndexOrdernarPorNome);
        click(tabIndexOrdernarPorNome);
        waitForInvisibilityOfElementLocated(loadingWait);
    };
    public void selecionarOrdemPorNome(){

        waitForVisibilityOfElementLocated(OrdernarPorNome);
        click(OrdernarPorNome);
        waitForInvisibilityOfElementLocated(loadingWait);
    };
    public void campoProdutoInicial(){
        waitForVisibilityOfElementLocated(IconSearchProdutoInicial);
        click(IconSearchProdutoInicial);
        waitForInvisibilityOfElementLocated(loadingWait);
    };
    public void buscaProduto(String descProduto){

        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl,descProduto);
        waitForInvisibilityOfElementLocated(loadingWait);
    };
    public void selecionarProdutoInicial(){
        waitForVisibilityOfElementLocated(produto);
        click(produto);
        waitForInvisibilityOfElementLocated(loadingWait);

    };
    public void campoProdutoFinal(){
        waitForVisibilityOfElementLocated(IconSearchProdutoFinal);
        click(IconSearchProdutoFinal);
        waitForInvisibilityOfElementLocated(loadingWait);
    };
    public void buscarProdutoFinal(String descProduto){
        waitForVisibilityOfElementLocated(campoProcurarFloatControl);
        click(campoProcurarFloatControl);
        sendKeys(campoProcurarFloatControl,descProduto);
        waitForInvisibilityOfElementLocated(loadingWait);
    };
    public void selecionarProdutoFinal(){
        waitForVisibilityOfElementLocated(produtoFinal);
        click(produtoFinal);
        waitForInvisibilityOfElementLocated(loadingWait);
    };
    public void buttonGrid() {
        waitForVisibilityOfElementLocated(btnEmGrid);
        click(btnEmGrid);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public String validarGrid(){return getText(gridRelatorioPosicao);}

    //Gerar posição de Estoque  PDF

    public void buttonGerarPDF(){
        waitForVisibilityOfElementLocated(gerarPDF);
        click(gerarPDF);
        waitForInvisibilityOfElementLocated(loadingWait);

    }

    // Gerar Posição de Estoque XLSX
    public void buttonGerarXLSX(){
        waitForVisibilityOfElementLocated(gerarXLSX);
        click(gerarXLSX);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
}
